=== debian/changelog ===
freecell-solver (4.8.0-1) unstable; urgency=medium

  * Imported upstream version 4.8.0 (closes: #841445)

 -- Gergely Risko <risko@debian.org>  Sat, 28 Jan 2017 10:27:50 +0100
