## freecell-solver 4.16.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,9 +1,6 @@
 CMAKE_MINIMUM_REQUIRED(VERSION 3.0)
 
-SET (private_mod_path "${CMAKE_SOURCE_DIR}/cmake")
-LIST (APPEND CMAKE_MODULE_PATH "${private_mod_path}")
-INCLUDE(Shlomif_Common)
-
+INCLUDE ("${CMAKE_SOURCE_DIR}/cmake/shlomif_common_bootstrap.cmake")
 SHLOMIF_COMMON_SETUP("${private_mod_path}")
 
 CMAKE_POLICY(SET CMP0054 NEW)
@@ -34,15 +31,17 @@
     "~$"
     "\\\\.pyc$"
     "/tags$"
+    "fcs-freecell-24\\\\.txt$"
     "^${PROJECT_SOURCE_DIR}/ids\\\\.txt$"
     "^${PROJECT_SOURCE_DIR}/scripts/ids-whitelist(\\\\.txt)?"
     "/(build|BUILD|B)/"
     "/Presets/testing-presets"
-    "^${PROJECT_SOURCE_DIR}/patsolve-shlomif/\\\\.(git|hg)"
-    "^${PROJECT_SOURCE_DIR}/patsolve-shlomif/patsolva/ga"
-    "^${PROJECT_SOURCE_DIR}/patsolve-shlomif/patsolve/(COPYING|Manifest|check_layout|convert_[a-z]+|fc-solve\\\\.ico|dondorf-king\\\\.bmp|threaded_main\\\\.c|patmain\\\\.c|run-tests\\\\.pl|read_layout\\\\.h|print_layout\\\\.h)$"
+    "^${PROJECT_SOURCE_DIR}/patsolve-shlomif/(\\\\.(git|hg)|appveyor|\\\\.travis|CI-testing)"
+    "^${PROJECT_SOURCE_DIR}/patsolve-shlomif/patsolve/(OLD|Rejects|cmake|ga|patsolve-specific|t/)"
+    "^${PROJECT_SOURCE_DIR}/patsolve-shlomif/patsolve/(CMakeLists\\\\.txt|COPYING|Manifest|Parameters|check_layout|config\\\\.h\\\\.in|convert_[a-z]+|fc-solve\\\\.ico|dondorf-king\\\\.bmp|threaded_main\\\\.c|patmain\\\\.c|run-tests\\\\.pl|read_layout\\\\.h|print_layout\\\\.h)$"
 )
 
+SET(_win32_static_lib_flags )
 IF(WIN32 AND NOT UNIX)
     # There is a bug in NSI that does not handle full unix paths properly. Make
     # sure there is at least one set of four (4) backlasshes.
@@ -58,11 +57,18 @@
     SET(CPACK_NSIS_MUI_UNIICON ${CPACK_NSIS_MUI_ICON})
     SET(CPACK_PACKAGE_ICON ${CPACK_NSIS_MUI_ICON})
     SET(CPACK_NSIS_MODIFY_PATH "ON")
+    IF (${CMAKE_COMPILER_IS_GNUCC})
+        IF (CMAKE_BUILD_TYPE STREQUAL release)
+            SET (_win32_static_lib_flags "-static-libgcc" "-static-libstdc++")
+        ENDIF ()
+    ENDIF ()
 ELSE()
   SET(CPACK_STRIP_FILES "fc-solve")
   SET(CPACK_SOURCE_STRIP_FILES "")
 ENDIF()
 
+    # See:
+    # https://stackoverflow.com/questions/4702732/the-program-cant-start-because-libgcc-s-dw2-1-dll-is-missing#4703059
 SET(CPACK_PACKAGE_EXECUTABLES
     "fc-solve" "Single-Game Solver"
 )
@@ -139,14 +145,22 @@
 option (FCS_WITHOUT_FC_PRO_MOVES_COUNT "Don't include the code and functionality of FC-Pro moves count.")
 option (FCS_WITHOUT_TRIM_MAX_STORED_STATES "Don't include the trim-max-stored-states-functionality (should make things faster).")
 option (FCS_WITHOUT_ITER_HANDLER "Don't include the iteration handler functionality (should make things faster).")
+option (FCS_WITHOUT_MAX_NUM_STATES "Don't include the iterations limit functionality (should make things faster).")
+option (FCS_WITHOUT_CMD_LINE_HELP "Don't include the cmd line help (should make things faster).")
 option (FCS_DISABLE_MULTI_FLARES "Disable the multi-flaring functionality. May make things faster but break compatibilty. Enable at your own risk.")
+option (FCS_DISABLE_MULTI_NEXT_INSTS "Disable the --next-instance/-ni functionality. May make things faster but break compatibilty. Enable at your own risk.")
 option (FCS_DISABLE_MOVES_TRACKING "Disable the moves-tracking functionality. May make things faster but break a lot of compatibilty. Enable at your own risk.")
+option (FCS_DISABLE_NUM_STORED_STATES "Disable the num-stored-states functionality. May make things faster but breaks compatibilty. Enable at your own risk.")
 option (FCS_DISABLE_ERROR_STRINGS "Disables passing/setting the error strings - breaks a lot of compatibility - enable at your own risk.")
 option (FCS_DISABLE_STATE_VALIDITY_CHECK "Disable the state validity check. May make things faster but breaks some compatibilty. Enable at your own risk.")
 option (FCS_HARD_CODE_SCANS_SYNERGY_AS_TRUE "Make scan synergy as always true. Reduces functionality but may make things faster.")
 option (FCS_HARD_CODE_REPARENT_STATES_AS_FALSE "Make reparent states as always false. Reduces functionality but may make things faster.")
 option (FCS_HARD_CODE_CALC_REAL_DEPTH_AS_FALSE "Make calc-real-depth as always false. Reduces functionality but may make things faster.")
 option (FCS_WITHOUT_EXPORTED_RESUME_SOLUTION "Don't export resume_solution. Breaks compat but may make things faseer. Enable at your own risk.")
+option (FCS_ENABLE_PRUNE__R_TF__UNCOND "Hard code -sp as 'r:tf' (may be useful for speedup but breaks functionality.)")
+option (FCS_USE_PRECOMPILED_CMD_LINE_THEME "Hard code a command line theme as generated by the compiler (useful for speedup but breaks functionality.)")
+option (FCS_AVOID_INT128 "Avoid using GCC's __int128 extension (used for debugging)")
+
 
 IF (NOT (STATES_TYPE MATCHES "^(INDIRECT_STACK_STATES|COMPACT_STATES)$"))
     MESSAGE(FATAL_ERROR "STATES_TYPE should be ('INDIRECT_STACK_STATES', or 'COMPACT_STATES')")
@@ -155,6 +169,7 @@
 SET (${STATES_TYPE} 1)
 
 IF (FCS_ENABLE_RCS_STATES)
+    SET (FCS_DISABLE_MOVES_TRACKING 0)
     SET (FCS_RCS_STATES 1)
 ENDIF ()
 
@@ -162,7 +177,7 @@
 SET (pats_dir "patsolve-shlomif")
 
 IF (NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/${pats_dir}")
-    EXECUTE_PROCESS(COMMAND "git" "clone" "--branch" "make-code-suitable-for-fc-solve" "git@github.com:shlomif/patsolve.git" "${pats_dir}"
+    EXECUTE_PROCESS(COMMAND "git" "clone" "https://github.com/shlomif/patsolve.git" "${pats_dir}"
         WORKING_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}"
     )
 ENDIF ()
@@ -172,6 +187,7 @@
     LIST(APPEND _gen_c_files ${ARGV})
 ENDMACRO ()
 
+SET (MOVE_GEN_MOD "${CMAKE_CURRENT_SOURCE_DIR}/t/lib/FC_Solve/MoveFuncs.pm")
 SET (presets_gen "${CMAKE_CURRENT_SOURCE_DIR}/scripts/gen_presets.pl")
 SET (presets_gen_output "${CMAKE_CURRENT_BINARY_DIR}/fcs_presets_generated.h")
 SET (presets_gen_args "${presets_gen}" "--mode=c" "--output" "${presets_gen_output}")
@@ -179,47 +195,3 @@
 # We do this so there will be no need to run "make" first.
 # See: http://github.com/kripken/emscripten/issues/766#issuecomment-11771150
 ADD_CUSTOM_COMMAND(
-    OUTPUT "${presets_gen_output}"
-    COMMAND "${PERL_EXECUTABLE}"
-    ARGS ${presets_gen_args}
-    DEPENDS "${presets_gen}"
-)
-SET (rate_state_gen "${CMAKE_CURRENT_SOURCE_DIR}/scripts/gen_rate_state_c.pl")
-SET (rate_state_args "${rate_state_gen}" "${CMAKE_CURRENT_SOURCE_DIR}")
-SET (rate_state_output "${CMAKE_CURRENT_BINARY_DIR}/rate_state.c")
-add_gen_c("${rate_state_output}")
-# We do this so there will be no need to run "make" first.
-# See: http://github.com/kripken/emscripten/issues/766#issuecomment-11771150
-ADD_CUSTOM_COMMAND(
-    OUTPUT "${rate_state_output}"
-    COMMAND "${PERL_EXECUTABLE}"
-    ARGS ${rate_state_args}
-    DEPENDS "${rate_state_gen}" "${CMAKE_CURRENT_SOURCE_DIR}/rate_state.h"
-)
-
-EXECUTE_PROCESS(COMMAND "perl" ${rate_state_args})
-
-SET (patsolve_dir "${pats_dir}/patsolve")
-SET (p_dir "${patsolve_dir}")
-
-SET (patsolve_modules
-    "${p_dir}/param.c"
-    "${p_dir}/pat.c"
-    "${p_dir}/patsolve.c"
-    "${p_dir}/tree.c"
-    )
-
-FIND_PROGRAM(_GPERF "gperf")
-
-IF ("${_GPERF}" STREQUAL "_GPERF-NOTFOUND")
-    MESSAGE(FATAL_ERROR "gperf must be in the path - see https://www.gnu.org/software/gperf/ .")
-ENDIF ()
-
-SET (CL_INC_H "cmd_line_inc.h")
-SET (BIN_CL_INC_H "${CMAKE_CURRENT_BINARY_DIR}/${CL_INC_H}")
-SET (CL_INC_SCRIPT "scripts/gen-cmd-line-radix-tree.pl")
-SET (cl_enum_h "${CMAKE_CURRENT_BINARY_DIR}/cmd_line_enum.h")
-
-add_gen_c("${BIN_CL_INC_H}" "${cl_enum_h}")
-ADD_CUSTOM_COMMAND(
-    OUTPUT
