=== board_gen/CMakeLists.txt ===
--- 
+++ 
@@ -28,6 +28,7 @@
     )
 ENDMACRO()
 
+my_board_gen_prog("find-freecell-deal-index.py" "find_index_prog")
 my_board_gen_prog("make_pysol_freecell_board.py" "make_pysol_board")
 my_board_gen_prog("transpose-freecell-board.py" "transpose_freecell_board_prog")
 # Empty list
@@ -69,8 +70,12 @@
         "bin"
 )
 
-
 ADD_CUSTOM_TARGET(
     "docs_pods" ALL
     DEPENDS ${_pod_targets}
 )
+
+ADD_LIBRARY (fcs_find_deal
+    SHARED
+    find_deal.c
+)
