=== t/CMakeLists.txt ===
--- 
+++ 
@@ -73,6 +73,7 @@
     )
 
     FILE (MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/t")
+    FILE (MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/verify-cache")
 
     SET (EXE_FILE "bit-reader-and-writer-test.t.exe")
 
@@ -175,6 +176,9 @@
     LIST(APPEND test_tags ${ARGV})
 ENDMACRO ()
 
+IF (FCS_BREAK_BACKWARD_COMPAT_1)
+    add_tag("break_backcompat")
+ENDIF ()
 IF (FCS_FREECELL_ONLY)
     add_tag("fc_only")
 ENDIF ()
