=== debian/changelog ===
freecell-solver (4.16.0-1) unstable; urgency=medium

  *  Imported upstream version 4.16.0

 -- Gergely Risko <risko@debian.org>  Mon, 12 Feb 2018 22:01:00 +0100

freecell-solver (4.14.1-1) unstable; urgency=medium

  * Imported upstream version 4.14.1

 -- Gergely Risko <risko@debian.org>  Tue, 24 Oct 2017 19:24:27 +0200
