=== debian/control ===
--- 
+++ 
@@ -8,7 +8,7 @@
  debhelper,
  dh-buildinfo
 Homepage: http://fc-solve.shlomifish.org/
-Standards-Version: 3.9.8
+Standards-Version: 4.1.1
 
 Package: libfreecell-solver0
 Architecture: any
