## freecell-solver 4.18.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -39,6 +39,7 @@
     "^${PROJECT_SOURCE_DIR}/patsolve-shlomif/(\\\\.(git|hg)|appveyor|\\\\.travis|CI-testing)"
     "^${PROJECT_SOURCE_DIR}/patsolve-shlomif/patsolve/(OLD|Rejects|cmake|ga|patsolve-specific|t/)"
     "^${PROJECT_SOURCE_DIR}/patsolve-shlomif/patsolve/(CMakeLists\\\\.txt|COPYING|Manifest|Parameters|check_layout|config\\\\.h\\\\.in|convert_[a-z]+|fc-solve\\\\.ico|dondorf-king\\\\.bmp|threaded_main\\\\.c|patmain\\\\.c|run-tests\\\\.pl|read_layout\\\\.h|print_layout\\\\.h)$"
+    "^${PROJECT_SOURCE_DIR}/xxHash-wrapper/(\\\\.git)"
 )
 
 SET(_win32_static_lib_flags )
@@ -193,5 +194,3 @@
 SET (presets_gen_args "${presets_gen}" "--mode=c" "--output" "${presets_gen_output}")
 add_gen_c("${presets_gen_output}")
 # We do this so there will be no need to run "make" first.
-# See: http://github.com/kripken/emscripten/issues/766#issuecomment-11771150
-ADD_CUSTOM_COMMAND(
