=== t/CMakeLists.txt ===
--- 
+++ 
@@ -88,7 +88,6 @@
         "bit-reader-and-writer-test.c"
         PROPERTIES
             OBJECT_DEPENDS "${CMAKE_CURRENT_SOURCE_DIR}/../bit_rw.h"
-            GENERATED "1"
     )
 
     IF ("${DEBONDT_DELTA_STATES}")
