=== debian/changelog ===
freecell-solver (4.18.0-1) unstable; urgency=medium

  * Imported upstream version 4.18.0

 -- Gergely Risko <risko@debian.org>  Sat, 05 May 2018 23:35:29 +0200
