=== debian/rules ===
--- 
+++ 
@@ -19,3 +19,6 @@
 	mkdir -p debian/freecell-solver-bin/usr/share/lintian/overrides/
 	cp debian/freecell-solver-bin.lintian debian/freecell-solver-bin/usr/share/lintian/overrides/freecell-solver-bin
 	cp board_gen/README debian/freecell-solver-bin/usr/share/doc/freecell-solver-bin/README.board_gen
+	mkdir -p debian/libfreecell-solver-dev/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig
+	mv debian/libfreecell-solver-dev/usr/lib/pkgconfig/libfreecell-solver.pc debian/libfreecell-solver-dev/usr/lib/${DEB_HOST_MULTIARCH}/pkgconfig
+	rmdir debian/libfreecell-solver-dev/usr/lib/pkgconfig
